function tk=KT_fb(y,L,M)
% y - samples
% L - predictor order
% M - number of diracs

N=length(y);

% build matrices
A=zeros(N-L,L);
B=zeros(N-L,L);

for i=0:N-L-1
    A(i+1,:)=y((L:-1:1)+i)  ;
    B(i+1,:)=conj(y((2:(L+1))+i)  );
end

A=[A;B];

h=-[(y(L+1:N)).' ; (y(1:N-L))'];

R=A'*A;
r=-A'*h;

[U,V]=eig(R);

g=zeros(L,1);

% find filter coefficients
for i=0:M-1
    g=g+U(:,end-i)'*r/V(end-i,end-i)*U(:,end-i);
end

z=roots([-1;g]);
[B,I]=sort(abs(z));
tk=sort(mod(-angle(z(I(end-M+1:end)))/(2*pi)*1,1));
end