function c=ExpSamp(tl,al,p,T,alpha,beta)

% tl - row vectors of delays
% al - row vectors of gains
% p - sampling channels
% T - period

L=length(tl);
i=0:p-1;

[Tl,ii]=meshgrid(tl,i);
W=(T-Tl).^(ii-1);
W=exp(-(alpha+beta*ii).*(T-Tl));

c=W*al';


