function tl=MultiRecoverMix(c,S,T,L)
% c - samples
% S - mixing matrix
% T - period
% L - number of diracs

%% recover fourier coeff
x=pinv(S)*c;
p=size(S,1);

if p>=2*L
    tl=KT_fb(x.',floor(2/3*p),L);
else
    tl=AnnFilter(x,L,T);
end

